/* GCC */

#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point
{
       long X, Y;  
       bool operator == (Point p)
       {
            return this->X == p.X && this->Y == p.Y;     
       }
       Point() {}
       Point(long x, long y) : X(x), Y(y) {}
};

long N;
vector<Point> Mosqs;
Point pid1, pid2;

inline void CheckRight(const Point &p1, const Point &p2, long &max, long &start)
{
     long res = 0;
     for(long i = start; i < N; i++)
     {
             if(Mosqs[i].X <= p2.X
             && Mosqs[i].Y >= p1.Y && Mosqs[i].Y <= p2.Y)
                res++; 
             else if(Mosqs[i].X > p2.X)
                break;
     }
     if(res > max)
            max = res;
}

inline void CheckLeft(const Point &p1, const Point &p2, long &max, long &start)
{
     long res = 0;
     for(long i = start; i >= 0; i--)
     {
             if(Mosqs[i].X >= p1.X
             && Mosqs[i].Y >= p1.Y && Mosqs[i].Y <= p2.Y)
                res++; 
             else if(Mosqs[i].X < p2.X)
                break;
     }
     if(res > max)
            max = res;
}

void Input()
{
     stringstream ss;
     ifstream fin("mosquito.in");
     ss<<fin.rdbuf();
     fin.close();    
     
     ss>>N;
     Mosqs.resize(N);
     for(long i = 0; i < N; i++)
             ss>>Mosqs[i].X>>Mosqs[i].Y;
     long W, H;
     ss>>W>>H;
     pid1 = Point(W, H);
     pid2 = Point(H, W);
}

inline bool sortbyX (Point p1, Point p2)
{
     return p1.X < p2.X;
}

int main()
{
      Input();
      long max = 0;
      sort(Mosqs.begin(), Mosqs.end(), sortbyX);
      
      if(pid1 == pid2)
      {
              for(long i = 0; i < N; i++)
              {
                      Point p1 = Mosqs[i];
                      CheckRight(p1, Point(p1.X + pid1.X, p1.Y + pid1.Y), max, i);  
                      CheckLeft(Point(p1.X - pid1.X, p1.Y - pid1.Y), p1, max, i);  
                      CheckLeft(Point(p1.X - pid1.X, p1.Y), Point(p1.X, p1.Y + pid1.Y), max, i);
                      CheckRight(Point(p1.X, p1.Y - pid1.Y), Point(p1.X + pid1.X, p1.Y), max, i);
              }
      }
      else
      {
              for(long i = 0; i < N; i++)
              {
                      Point p1 = Mosqs[i];
                      CheckRight(p1, Point(p1.X + pid1.X, p1.Y + pid1.Y), max, i);  
                      CheckLeft(Point(p1.X - pid1.X, p1.Y - pid1.Y), p1, max, i);  
                      CheckLeft(Point(p1.X - pid1.X, p1.Y), Point(p1.X, p1.Y + pid1.Y), max, i);
                      CheckRight(Point(p1.X, p1.Y - pid1.Y), Point(p1.X + pid1.X, p1.Y), max, i);
                      
                      CheckRight(p1, Point(p1.X + pid2.X, p1.Y + pid2.Y), max, i);  
                      CheckLeft(Point(p1.X - pid2.X, p1.Y - pid2.Y), p1, max, i);  
                      CheckLeft(Point(p1.X - pid2.X, p1.Y), Point(p1.X, p1.Y + pid2.Y), max, i);
                      CheckRight(Point(p1.X, p1.Y - pid2.Y), Point(p1.X + pid2.X, p1.Y), max, i); 
              }
      }
      
      //for(int i = 0; i < N; i++)
      //        cout<<Mosqs[i].X<<' '<<Mosqs[i].Y<<endl;
      //int i; cin>>i;
      
      ofstream fout("mosquito.out");
      fout<<max<<endl;
      fout.close();
      
      return 0;
}
